package problem_1;

public class DogUtilitiesTest {

	public static void main(String[] args) {
		testGetEveryOther_EvenNumDogs();
		testGetEveryOther_OddNumDogs();
		testCreateMutants();

	}
	
	public static void testGetEveryOther_EvenNumDogs() {
		System.out.println("-->testGetEveryOther_EvenNumDogs()");
		DogUtilities d = new DogUtilities();
		Dog[] dogs = new Dog[4];
		dogs[0] = new Dog("Cosmos");
		dogs[1] = new Dog("Fancy", 3);
		dogs[2] = new Dog("Reji", 7);
		dogs[3] = new Dog("Bongo", 9);
		
		Dog[] dogs2 = d.getEveryOther(dogs);
		
		String expected = "Expected: \n1. Cosmos\n2. Reji\n";
		
		StringBuilder actual = new StringBuilder("Actual: ");
		for(int i = 0; i < dogs2.length; i++) {
			actual.append("\n" + (i+1) + ". " + dogs2[i].getName());
		}
		
		System.out.println(expected);
		System.out.println(actual);
	}
	
	public static void testGetEveryOther_OddNumDogs() {
		System.out.println("\n -->testGetEveryOther_OddNumDogs()");
		DogUtilities d = new DogUtilities();
		Dog[] dogs = new Dog[5];
		dogs[0] = new Dog("Cosmos");
		dogs[1] = new Dog("Fancy", 3);
		dogs[2] = new Dog("Reji", 7);
		dogs[3] = new Dog("Bongo", 9);
		dogs[4] = new Dog("Glinda", 8);
		
		Dog[] dogs2 = d.getEveryOther(dogs);
		
		String expected = "Expected: \n1. Cosmos\n2. Reji\n3. Glinda\n";
		
		StringBuilder actual = new StringBuilder("Actual: ");
		for(int i = 0; i < dogs2.length; i++) {
			actual.append("\n" + (i+1) + ". " + dogs2[i].getName());
		}
		
		System.out.println(expected);
		System.out.println(actual);
	}
	
	public static void testCreateMutants() {
		System.out.println("\n-->testCreateMutants()");
		DogUtilities d = new DogUtilities();
		Dog[] dogs = new Dog[4];
		dogs[0] = new Dog("Fido", 3);
		dogs[1] = new Dog("Snoopy", 4);
		dogs[2] = new Dog("Leo", 2);
		dogs[3] = new Dog("Cosmos");
		
		Dog[] dogs2 = d.createMutants(dogs);
		
		String expected = String.format("Expected: \nname: %s, age=%d\n"
												+ "name: %s, age=%d\n"
												+ "name: %s, age=%d\n"
												+ "name: %s, age=%d\n",
												"id",3,"noop",4,"e",2,"osmo",1);
		
		String actual = String.format("Actual: \nname: %s, age=%d\n"
											  + "name: %s, age=%d\n"
											  + "name: %s, age=%d\n"
											  + "name: %s, age=%d\n",
											  dogs2[0].getName(), dogs2[0].getAge(),
											  dogs2[1].getName(), dogs2[1].getAge(),
											  dogs2[2].getName(), dogs2[2].getAge(),
											  dogs2[3].getName(), dogs2[3].getAge());
		
		System.out.println(expected);
		System.out.println(actual);
	}

}
