package problem_2;

public class Circle {
	private double x;
	private double y;
	private double radius;
	private String color;
	
	public Circle(double radius) {
		this(0.0, 0.0, radius, "orange");
	}
	
	public Circle(double x, double y) {
		this(x, y, 1.0, "purple");
	}
	
	public Circle(double x, double y, double radius, String color) {
		this.x = x;
		this.y = y;
		this.radius = radius;
		this.color = color;
	}

	public double getX() {
		return x;
	}

	public double getY() {
		return y;
	}

	public double getRadius() {
		return radius;
	}

	public String getColor() {
		return color;
	}
	
	public double area() {
		return Math.PI * Math.pow(radius, 2);
	}
	
	public double distanceFrom(Circle c) {
		double distance = Math.sqrt(Math.pow(c.x-x, 2) + Math.pow(c.y-y, 2));
		return distance;
	}
	
	public void merge(Circle c) {
		x = (x+c.x)/2;
		y = (y+c.y)/2;
		radius = (radius+c.radius)/2;
		color = c.color;
	}

	// Incorrect
//	public Circle closestTo(Circle[] circles) {
//		Circle c = new Circle(1.0);
//		
//		for(int i = 0; i < circles.length; i++) {
//			double distance = Double.MAX_VALUE;
//			if(this.distanceFrom(circles[i]) < distance) {
//				distance = this.distanceFrom(circles[i]);
//				c.x = circles[i].x;
//				c.y = circles[i].y;
//				c.radius = circles[i].radius;
//				c.color = circles[i].color;
//			}
//		}
//		return c;
//	}

	public Circle closestTo(Circle[] circles) {
		Circle c = null;
		double distance = Double.MAX_VALUE;
		
		for(int i = 0; i < circles.length; i++) {
			if(this.distanceFrom(circles[i]) < distance) {
				distance = this.distanceFrom(circles[i]);
				c = circles[i];
			}
		}
		return c;
	}

	public boolean hasTwoOrMoreVowels() {
		int vowelCount = 0;
		char[] vowels = {'a', 'e', 'i', 'o', 'u'};
		
		for(int i = 0; i < color.length(); i++) {
			char currentLetter = color.charAt(i);
			currentLetter = Character.toLowerCase(currentLetter);
			for(int j = 0; j < vowels.length; j++) {
				if(currentLetter == (vowels[j])) {
					vowelCount++;
				}
			}
		}
		if(vowelCount >= 2) {
			return true;
		}
		return false;
	}
	
	public void moveXBy(double x) {
		this.x += x;
	}
	
	public void moveXY(double x, double y) {
		this.x += x;
		this.y += y;
	}
	
	public void moveYBy(double y) {
		this.y += y;
	}
	
	public int sumSameColor(Circle[] circles) {
		int count = 0;
		for(Circle circle : circles) {
			if(circle.color == color) {
				count++;
			}
		}
		return count;
	}
	
	public void swap() {
		double temp = x;
		x = y;
		y = temp;
	}
	
	@Override
	public String toString() {
		String msg = String.format("x=%.2f, y=%.2f", x, y);
		return msg;
	}
}
