package problem_2;

public class CircleTest {

	public static void main(String[] args) {
		testCircleCreation();
		testMoveXY();
		testCalculateDistanceFrom();
		testHasTwoOrMoreVowels_True();
		testHasTwoOrMoreVowels_False();
		testClosestTo();

	}

	public static void testCircleCreation() {
		System.out.println("-->testCircleCreation()");
		Circle c1 = new Circle(3.0, 2.4, 7.0, "yellow");
		Circle c2 = new Circle(2.5, 3.2);
		Circle c3 = new Circle(8.0);
		
		String expected = "Expected: c1.x = 3.0"
						+ "          c1.y = 2.4"
						+ "          c1.radius = 7.0"
						+ "          c1.color = yellow"
						+ "          c2.x = 2.5"
						+ "          c2.y = 3.2"
						+ "          c2.radius = 1.0"
						+ "          c2.color = purple"
						+ "          c3.x = 0.0"
						+ "          c3.y = 0.0"
						+ "          c3.radius = 8.0"
						+ "          c3.color = orange";
		
		String actual = String.format("  Actual: c1.x = %.1f"
						+ "          c1.y = %.1f"
						+ "          c1.radius = %.1f"
						+ "          c1.color = %s"
						+ "          c2.x = %.1f"
						+ "          c2.y = %.1f"
						+ "          c2.radius = %.1f"
						+ "          c2.color = %s"
						+ "          c3.x = %.1f"
						+ "          c3.y = %.1f"
						+ "          c3.radius = %.1f"
						+ "          c3.color = %s", c1.getX(), c1.getY(), c1.getRadius(), c1.getColor(),
													 c2.getX(), c2.getY(), c2.getRadius(), c2.getColor(),
													 c3.getX(), c3.getY(), c3.getRadius(), c3.getColor());
		
		System.out.println(expected);
		System.out.println(actual);

	}
	
	public static void testMoveXY() {
		System.out.println("\n-->testMoveXY()");
		Circle c = new Circle(2.0, 1.5);
		c.moveXY(3.0, 4.0);
		
		String expected = String.format("Expected: x=%.2f, y=%.2f", 5.00, 5.50);
		String actual = "  Actual: " + c.toString();
		
		System.out.println(expected);
		System.out.println(actual);
	}
	
	public static void testCalculateDistanceFrom() {
		System.out.println("\n-->testCalculateDistanceFrom()");
		Circle c1 = new Circle(2.0, 1.5);
		Circle c2 = new Circle(5.2, 4.6);
		double distance = c1.distanceFrom(c2);
		
		String expected = "Expected: distance from c1 to c2 = 4.455333882";
		String actual = String.format("  Actual: distance from c1 to c2 = %.9f", distance);
		
		System.out.println(expected);
		System.out.println(actual);
	}
	
	public static void testHasTwoOrMoreVowels_False() {
		System.out.println("\n-->testHasTwoOrMoreVowels_False()");
		Circle c = new Circle(2.0, 3.6, 5.2, "red");
		
		boolean hasTwoOrMoreVowels = c.hasTwoOrMoreVowels();

		
//		boolean hasTwoOrMoreVowels;
//		if(c.hasTwoOrMoreVowels()) {
//			hasTwoOrMoreVowels = true;
//		} 
//		else {
//			hasTwoOrMoreVowels = false;
//		}
		
		String expected = "Expected: Circle's color has 2 or more vowels = false";
		String actual = "  Actual: Circle's color has 2 or more vowels = " + hasTwoOrMoreVowels;
		
		System.out.println(expected);
		System.out.println(actual);
	}
	
	public static void testHasTwoOrMoreVowels_True() {
		System.out.println("\n-->testHasTwoOrMoreVowels_True()");
		Circle c = new Circle(2.0, 3.6, 5.2, "Orange");
		
		boolean hasTwoOrMoreVowels = c.hasTwoOrMoreVowels();
		
		String expected = "Expected: Circle's color has 2 or more vowels = true";
		String actual = "  Actual: Circle's color has 2 or more vowels = " + hasTwoOrMoreVowels;
		
		System.out.println(expected);
		System.out.println(actual);
	}
	
	public static void testClosestTo() {
		System.out.println("\n-->testClosestTo()");
		Circle[] circles = createACircleArray_5_Circles();
		Circle c1 = new Circle(13.5, 10.9, 4.5, "magenta");
		
		Circle c2 = c1.closestTo(circles);
		
		String expected = "Expected: the closest circle to c1 with coordinates x=13.50, y=10.90 "
						+ "is the circle with coordinates x=11.20, y=5.90";
		String actual = String.format("  Actual: the closest circle to c1 with coordinates %s is the circle "
									+ "with coordinates %s", c1.toString(), c2.toString());
		
		System.out.println(expected);
		System.out.println(actual);
	}
	
	
	 /* Helper method */
	public static Circle[] createACircleArray_5_Circles() {
		Circle[] circles = new Circle[5];
		circles[0] = new Circle(3.2, 4.1, 6.5, "red");
		circles[4] = new Circle(2.5, 7.8, 5.0, "green");
		circles[2] = new Circle(4.7, 9.4, 8.3, "pink");
		circles[3] = new Circle(-1.7, 3.8, 9.1, "yellow");
		circles[1] = new Circle(11.2, 5.9, 8.6, "burgandy");
		
		return circles;
	}
}
